function Map() {     
	//alert('aaa');
    /** 存放键的数组(遍历用到) */    
    this.keys = new Array();     
    /** 存放数据 */    
    this.data = new Object();     
         
    /**   
     * 放入一个键值对   
     * @param {String} key   
     * @param {Object} value   
     */    
    this.put = function(key, value) {     
        if(this.data[key] == null){     
            this.keys.push(key);     
        }
        this.data[key] = value;     
    };     
         
    /**   
     * 获取某键对应的值   
     * @param {String} key   
     * @return {Object} value   
     */    
    this.get = function(_key) {     
    	var aa = "";
    	//try {
        	/*aa = this.data[_key];
        	if(aa = null || aa = ""){
        		aa = "";
        	}*/
		//} catch (e) {
			//aa = "";
		//}
    	//try {
    	//alert(this.data.length);
            for (i = 0; i < this.keys.length; i++) {
            	//alert("key::"+this.keys.length);
                if (this.keys[i] == _key) {
                	aa = this.data[_key];
                    return aa;   
                }
            }
        //} catch (e) {
        //	aa = "";
        //}
        	
        return aa;     
    };     
         
    /**   
     * 删除一个键值对   
     * @param {String} key   
     */    
    this.remove = function(_key) {   
        for (i = 0; i < this.keys.length; i++) {
        	//alert("key::"+this.keys.length);
            if (this.keys[i] == _key) {  
                this.keys.splice(i,1);
                break;
            }
        }
        this.data[_key] = null;
    };     
    /**   
     * 删除所有   
     * @param {String} key   
     */    
    this.removeAll = function() {   
        for (i = 0; i < this.keys.length; i++) {
        	//alert("key::"+this.keys.length);
            this.data[this.keys[i]] = null;
        }
        this.keys.splice(0,this.keys.length);
    };     
    /**   
     * 遍历Map,执行处理函数   
     *    
     * @param {Function} 回调函数 function(key,value,index){..}   
     */    
    this.each = function(fn){     
        if(typeof fn != 'function'){     
            return;     
        }     
        var len = this.keys.length;     
        for(var i=0;i<len;i++){     
            var k = this.keys[i];     
            fn(k,this.data[k],i);     
        }     
    };     
         
    /**   
     * 获取键值数组(类似Java的entrySet())   
     * @return 键值对象{key,value}的数组   
     */    
    this.entrys = function() {     
        var len = this.keys.length;     
        var entrys = new Array(len);     
        for (var i = 0; i < len; i++) {     
            entrys[i] = {     
                key : this.keys[i],     
                value : this.data[i]     
            };     
        }     
        return entrys;     
    };     
         
    /**   
     * 判断Map是否为空   
     */    
    this.isEmpty = function() {     
        return this.keys.length == 0;     
    };     
         
    /**   
     * 获取键值对数量   
     */    
    this.size = function(){     
        return this.keys.length;     
    };
    /**   
     * 重写toString    
     */    
    this.toString = function(){     
        var s = "{";     
        for(var i=0;i<this.keys.length;i++){     
            var k = this.keys[i];     
            s += k+"="+this.data[k]; 
            if(i != (this.keys.length-1)){
            	s+=',';
            }
        }     
        s+="}";     
        return s;     
    };   
    this.toJsonString = function(){     
        var s = "{";     
        for(var i=0;i<this.keys.length;i++){     
            var k = this.keys[i];     
            s += ""+k+":'"+this.data[k] +"'"; 
            if(i != (this.keys.length-1)){
            	s+=',';
            }
        }     
        s+="}";     
        return s;     
    };  
    this.keyToString = function(){
    	if(this.keys.length == 0){
    		return "";
    	}
    	var s = "{";     
        for(var i=0;i<this.keys.length;i++){     
            s += this.keys[i];   
            if(i != (this.keys.length-1)){
            	s+=',';
            }
        }     
        s+="}";
        return s;
    }
    this.keyToStringNoKH = function(){
    	if(this.keys.length == 0){
    		return "";
    	}
    	var s = "";     
        for(var i=0;i<this.keys.length;i++){     
            s += this.keys[i];   
            if(i != (this.keys.length-1)){
            	s+=',';
            }
        }     
        s+="";
        return s;
    }
    this.valueToString = function(){
    	if(this.keys.length == 0){
    		return "";
    	}
    	var s = "{";     
        for(var i=0;i<this.keys.length;i++){     
        	var k = this.keys[i];     
            s += this.data[k];
            if(i != (this.keys.length-1)){
            	s+=',';
            }
        }     
        s+="}";     
        return s;
    }
    this.valueToStringNoKH = function(){
    	if(this.keys.length == 0){
    		return "";
    	}
    	var s = "";     
        for(var i=0;i<this.keys.length;i++){     
        	var k = this.keys[i];  
            s += this.data[k];
            if(i != (this.keys.length-1)){
            	s+=',';
            }
        }     
        s+="";     
        return s;
    }
    this.getKey = function(){
    	return this.keys;
    }
    this.getData = function(){
    	return this.data;
    }
    this.setData = function(dataStr){
    	dataStr = dataStr.substr(1,dataStr.length-2);
    	var dataA = dataStr.split(",");
    	for (var i = 0; i < dataA.length; i ++) {
    		var ss = dataA[i].split("=");
    		this.put(ss[0],ss[1]);
    	}
    }
}   