document.addEventListener( "plusready",  function()
{
    var _BARCODE = 'priplugin',
		B = window.plus.bridge;
    var priplugin = 
    {
		login : function (url, password, successCallback, errorCallback ){
			var success = typeof successCallback !== 'function' ? null : function(args) 
			{
				successCallback(args);
			},
			fail = typeof errorCallback !== 'function' ? null : function(code) 
			{
				errorCallback(code);
			};
			callbackID = B.callbackId(success, fail);
			return B.exec(_BARCODE, "login", [callbackID,url, password]);
		},
    	checkNFC : function (successCallback, errorCallback ){
			var success = typeof successCallback !== 'function' ? null : function(args) 
			{
				successCallback(args);
			},
			fail = typeof errorCallback !== 'function' ? null : function(code) 
			{
				errorCallback(code);
			};
			callbackID = B.callbackId(success, fail);
			return B.exec(_BARCODE, "checkNFC", [callbackID]);
		},
		readNFC : function (successCallback, errorCallback ){
			var success = typeof successCallback !== 'function' ? null : function(args) 
			{
				successCallback(args);
			},
			fail = typeof errorCallback !== 'function' ? null : function(code) 
			{
				errorCallback(code);
			};
			callbackID = B.callbackId(success, fail);
			return B.exec(_BARCODE, "readNFC", [callbackID]);
		},
		stopNFC : function (successCallback, errorCallback ){
			var success = typeof successCallback !== 'function' ? null : function(args) 
			{
				successCallback(args);
			},
			fail = typeof errorCallback !== 'function' ? null : function(code) 
			{
				errorCallback(code);
			};
			callbackID = B.callbackId(success, fail);
			return B.exec(_BARCODE, "stopNFC", [callbackID]);
		}
    };
    window.plus.priplugin = priplugin;
}, true );